<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<div class="w-100">
  <h5 class="fw-bold mb-3" [innerText]="messages.FAVORITE_DESKS_PREFERENCES_TITLE"></h5>

  <div class="w-50 mb-3">
    <h5 class="fw-bold" [innerText]="commonMessages.SEARCH_DESK"></h5>
    <app-search-bar
      class="search-input"
      (debouncedKeyup)="updateSearchTerm($event)"
      [placeholder]="commonMessages.SEARCH_DESK">
    </app-search-bar>
  </div>

  <div class="h-100 w-100 d-flex flex-row">

    <div class="w-50 pe-1">
      <h4 [innerText]="commonMessages.DESK_LIST"></h4>

      <div class="w-100 list-group rounded-0 list-striped border-top border-bottom max-height-list">
        <div
          class="d-flex justify-content-between list-group-item border-0 no-pointer"
          *ngFor="let desk of pendingNonFavoriteDesks">
          <span
            class="overflow-hidden text-overflow-ellipsis w-75"
            [innerText]="desk.name | namePipe">
          </span>
          <button
            ls-button
            class="borderless-ls-button text-primary m-0 p-0"
            [icon]="commonIcons.ADD_ICON"
            [disabled]="userPreferences?.favoriteDesks?.length >= 15"
            (click)="addToFavorite(desk)">
          </button>
        </div>
        <div
          class="p-2 text-center text-secondary fst-italic"
          *ngIf="pendingNonFavoriteDesks.length === 0"
          [innerText]="'Aucun bureau à affecter aux favoris.'">
        </div>
      </div>
    </div>

    <div class="w-50 ps-1">
      <div class="d-flex m-0 flex-row justify-content-between max-height-list">
        <h4 [innerText]="messages.EDIT_DESK_ORDER_FAVORITE_DESKS"></h4>
        <span
          class="me-3"
          [innerText]="messages.EDIT_DESK_ORDER_ORDER">
        </span>
      </div>
      <div
        cdkDropList
        class="w-100 list-group rounded-0 list-striped border-top border-bottom"
        (cdkDropListDropped)="drop($event)">
        <div
          cdkDragBoundary=".list-striped"
          class="d-flex list-group-item border-0 no-pointer"
          *ngFor="let desk of pendingFavoriteDesks; let i = index;"
          cdkDrag>
          <fa-icon
            class="me-3 delete-icon pointer"
            [icon]="commonIcons.CLOSE_ICON"
            (click)="removeFromFavorite(desk)">
          </fa-icon>
          <div class="overflow-hidden w-100 text-overflow-ellipsis">
            <span [innerText]="desk.name | namePipe"></span>
          </div>
          <div
            class="ms-3 example-handle d-flex"
            cdkDragHandle>
            <span
              class="me-1"
              [innerText]="i + 1">
            </span>
            <fa-icon
              class="text-primary"
              [icon]="gripHorizontalIcon">
            </fa-icon>
          </div>
        </div>


        <div
          class="p-2 text-center text-secondary fst-italic"
          *ngIf="pendingFavoriteDesks.length === 0"
          [innerText]="'Aucun bureau favoris.'">
        </div>
      </div>
    </div>

  </div>

  <div class="w-100">
    <button
      [text]="messages.PROFILE_VALIDATE"
      [processing]="isProcessing"
      (click)="saveForm()"
      ls-button-save
      class="mt-4">
    </button>
  </div>

</div>
